Subject: Re: [PATCH] fetch: align new ref summary printout in UTF-8 locales

From: Johannes Sixt <[email-masked]>
Date: Mon, 03 Sep 2012 22:01:17 +0200

Am 03.09.2012 21:26, schrieb Junio C Hamano:
> Nguyễn Thái Ngọc Duy  <[email-masked]> writes:
> 
>> fetch does printf("%-*s", width, "foo") where "foo" can be an utf-8
>> string, but width is bytes, not letters. This results in misaligned
>> ref summary table.
> 
> "but width is bytes, not letters" is a misleading statement.
> 
> Be careful about three different quantities when talking about
> aligning on terminal output with monospaced fonts:
> 
>  - How many bytes does the string occupy in memory?
>  - How many unicode codepoints are in the string?
>  - How many display columns does the string occupy on terminal?
> 
> Note that some "letters" (e.g. Han) occupy two display columns, and
> you want to measure the "width" and compensate that for "bytes".
> Letter count do not come into the picture for the purpose of aligning
> the terminal output.

If I'm reading POSIX correctly, printf measures the width in %*s in bytes.

-- Hannes